diff --git a/include/net/net_pkt.h b/include/net/net_pkt.h
index eb0829af3f3fff..31054cabac368a 100644
--- a/include/net/net_pkt.h
+++ b/include/net/net_pkt.h
@@ -1272,6 +1272,102 @@ static inline bool net_pkt_append_le32(struct net_pkt *pkt, u32_t data)
 			      K_FOREVER);
 }
 
+/**
+ * @brief Append u8_t data to last fragment in fragment list of a packet
+ *
+ * @details Append data to last fragment. If there is not enough space in last
+ * fragment then new data fragment will be created and will be added to
+ * fragment list. Caller has to take care of endianness if needed.
+ *
+ * @param pkt Network packet.
+ * @param data Data to be added
+ * @param timeout Timeout for buffer allocations
+ *
+ * @return True if all the data is placed at end of fragment list,
+ *         False otherwise (In-case of false pkt might contain input
+ *         data in the process of placing into fragments).
+ */
+static inline bool net_pkt_append_u8_timeout(struct net_pkt *pkt, u8_t data,
+					     s32_t timeout)
+{
+	return net_pkt_append_all(pkt, 1, &data, timeout);
+}
+
+/**
+ * @brief Append u16_t data to last fragment in fragment list of a packet
+ *
+ * @details Append data to last fragment. If there is not enough space in last
+ * fragment then new data fragment will be created and will be added to
+ * fragment list. Caller has to take care of endianness if needed.
+ *
+ * @param pkt Network packet.
+ * @param data Data to be added
+ * @param timeout Timeout for buffer allocations
+ *
+ * @return True if all the data is placed at end of fragment list,
+ *         False otherwise (In-case of false pkt might contain input data
+ *         in the process of placing into fragments).
+ */
+static inline bool net_pkt_append_be16_timeout(struct net_pkt *pkt,
+					       u16_t data,
+					       s32_t timeout)
+{
+	u16_t value = sys_cpu_to_be16(data);
+
+	return net_pkt_append_all(pkt, sizeof(u16_t), (u8_t *)&value,
+				  timeout);
+}
+
+/**
+ * @brief Append u32_t data to last fragment in fragment list of a packet
+ *
+ * @details Append data to last fragment. If there is not enough space in last
+ * fragment then new data fragment will be created and will be added to
+ * fragment list. Caller has to take care of endianness if needed.
+ *
+ * @param pkt Network packet.
+ * @param data Data to be added
+ * @param timeout Timeout for buffer allocations
+ *
+ * @return True if all the data is placed at end of fragment list,
+ *         False otherwise (In-case of false pkt might contain input data
+ *         in the process of placing into fragments).
+ */
+static inline bool net_pkt_append_be32_timeout(struct net_pkt *pkt,
+					       u32_t data,
+					       s32_t timeout)
+{
+	u32_t value = sys_cpu_to_be32(data);
+
+	return net_pkt_append_all(pkt, sizeof(u32_t), (u8_t *)&value,
+				  timeout);
+}
+
+/**
+ * @brief Append u32_t data to last fragment in fragment list
+ *
+ * @details Append data to last fragment. If there is not enough space in last
+ * fragment then new data fragment will be created and will be added to
+ * fragment list. Convert data to LE.
+ *
+ * @param pkt Network packet fragment list.
+ * @param data Data to be added
+ * @param timeout Timeout for buffer allocations
+ *
+ * @return True if all the data is placed at end of fragment list,
+ *         False otherwise (In-case of false pkt might contain input data
+ *         in the process of placing into fragments).
+ */
+static inline bool net_pkt_append_le32_timeout(struct net_pkt *pkt,
+					       u32_t data,
+					       s32_t timeout)
+{
+	u32_t value = sys_cpu_to_le32(data);
+
+	return net_pkt_append_all(pkt, sizeof(u32_t), (u8_t *)&value,
+				  timeout);
+}
+
 /**
  * @brief Get data from buffer
  *
@@ -1471,6 +1567,46 @@ static inline struct net_buf *net_pkt_write_be32(struct net_pkt *pkt,
 			     (u8_t *)&value, K_FOREVER);
 }
 
+/* Write u8_t data to an arbitrary offset in fragment. */
+static inline struct net_buf *net_pkt_write_u8_timeout(struct net_pkt *pkt,
+						       struct net_buf *frag,
+						       u16_t offset,
+						       u16_t *pos,
+						       u8_t data,
+						       s32_t timeout)
+{
+	return net_pkt_write(pkt, frag, offset, pos, sizeof(u8_t),
+			     &data, timeout);
+}
+
+/* Write u16_t big endian value to an arbitrary offset in fragment. */
+static inline struct net_buf *net_pkt_write_be16_timeout(struct net_pkt *pkt,
+							 struct net_buf *frag,
+							 u16_t offset,
+							 u16_t *pos,
+							 u16_t data,
+							 s32_t timeout)
+{
+	u16_t value = htons(data);
+
+	return net_pkt_write(pkt, frag, offset, pos, sizeof(u16_t),
+			     (u8_t *)&value, timeout);
+}
+
+/* Write u32_t big endian value to an arbitrary offset in fragment. */
+static inline struct net_buf *net_pkt_write_be32_timeout(struct net_pkt *pkt,
+							 struct net_buf *frag,
+							 u16_t offset,
+							 u16_t *pos,
+							 u32_t data,
+							 s32_t timeout)
+{
+	u32_t value = htonl(data);
+
+	return net_pkt_write(pkt, frag, offset, pos, sizeof(u32_t),
+			     (u8_t *)&value, timeout);
+}
+
 /**
  * @brief Insert data at an arbitrary offset in a series of fragments.
  *
@@ -1539,6 +1675,47 @@ static inline bool net_pkt_insert_be32(struct net_pkt *pkt,
 			      (u8_t *)&value, K_FOREVER);
 }
 
+/* Insert u8_t data at an arbitrary offset in a series of fragments. */
+static inline bool net_pkt_insert_u8_timeout(struct net_pkt *pkt,
+					     struct net_buf *frag,
+					     u16_t offset,
+					     u8_t data,
+					     s32_t timeout)
+{
+	return net_pkt_insert(pkt, frag, offset, sizeof(u8_t), &data,
+			      timeout);
+}
+
+/* Insert u16_t big endian value at an arbitrary offset in a series of
+ * fragments.
+ */
+static inline bool net_pkt_insert_be16_timeout(struct net_pkt *pkt,
+					       struct net_buf *frag,
+					       u16_t offset,
+					       u16_t data,
+					       s32_t timeout)
+{
+	u16_t value = htons(data);
+
+	return net_pkt_insert(pkt, frag, offset, sizeof(u16_t),
+			      (u8_t *)&value, timeout);
+}
+
+/* Insert u32_t big endian value at an arbitrary offset in a series of
+ * fragments.
+ */
+static inline bool net_pkt_insert_be32_timeout(struct net_pkt *pkt,
+					       struct net_buf *frag,
+					       u16_t offset,
+					       u32_t data,
+					       s32_t timeout)
+{
+	u32_t value = htonl(data);
+
+	return net_pkt_insert(pkt, frag, offset, sizeof(u32_t),
+			      (u8_t *)&value, timeout);
+}
+
 /**
  * @brief Split a fragment into two parts at arbitrary offset.
  *
diff --git a/subsys/net/ip/icmpv4.c b/subsys/net/ip/icmpv4.c
index ddf731022683a9..93f257ab818c7c 100644
--- a/subsys/net/ip/icmpv4.c
+++ b/subsys/net/ip/icmpv4.c
@@ -150,16 +150,19 @@ static inline enum net_verdict icmpv4_handle_echo_request(struct net_pkt *pkt)
 	return NET_OK;
 }
 
-static void icmpv4_create(struct net_pkt *pkt, u8_t icmp_type, u8_t icmp_code)
+static struct net_buf *icmpv4_create(struct net_pkt *pkt, u8_t icmp_type,
+				     u8_t icmp_code)
 {
 	struct net_buf *frag = pkt->frags;
 	u16_t pos;
 
 	net_buf_add(frag, sizeof(struct net_icmp_hdr));
 
-	frag = net_pkt_write_u8(pkt, frag, net_pkt_ip_hdr_len(pkt), &pos,
-				icmp_type);
-	frag = net_pkt_write_u8(pkt, frag, pos, &pos, icmp_code);
+	frag = net_pkt_write_u8_timeout(pkt, frag, net_pkt_ip_hdr_len(pkt),
+					&pos, icmp_type, PKT_WAIT_TIME);
+	frag = net_pkt_write_u8_timeout(pkt, frag, pos, &pos, icmp_code,
+					PKT_WAIT_TIME);
+	return frag;
 }
 
 int net_icmpv4_send_echo_request(struct net_if *iface,
@@ -170,6 +173,7 @@ int net_icmpv4_send_echo_request(struct net_if *iface,
 	struct net_if_ipv4 *ipv4 = iface->config.ip.ipv4;
 	const struct in_addr *src;
 	struct net_pkt *pkt;
+	int ret;
 
 	if (!ipv4) {
 		return -EINVAL;
@@ -184,12 +188,22 @@ int net_icmpv4_send_echo_request(struct net_if *iface,
 	 */
 	pkt = net_pkt_get_reserve_tx(net_if_get_ll_reserve(iface,
 					      (const struct in6_addr *)dst),
-				     K_FOREVER);
+				     PKT_WAIT_TIME);
+	if (!pkt) {
+		return -ENOMEM;
+	}
+
 	net_pkt_set_iface(pkt, iface);
 
-	net_ipv4_create(pkt, src, dst, iface, IPPROTO_ICMP);
+	if (!net_ipv4_create(pkt, src, dst, iface, IPPROTO_ICMP)) {
+		ret = -ENOMEM;
+		goto drop;
+	}
 
-	icmpv4_create(pkt, NET_ICMPV4_ECHO_REQUEST, 0);
+	if (!icmpv4_create(pkt, NET_ICMPV4_ECHO_REQUEST, 0)) {
+		ret = -ENOMEM;
+		goto drop;
+	}
 
 	net_buf_add(pkt->frags, sizeof(struct net_icmpv4_echo_req));
 
@@ -218,11 +232,23 @@ int net_icmpv4_send_echo_request(struct net_if *iface,
 
 	net_stats_update_icmp_drop(iface);
 
+	ret = -EIO;
+
+drop:
 	net_pkt_unref(pkt);
 
-	return -EIO;
+	return ret;
 }
 
+#define append(pkt, type, value)					\
+	do {								\
+		if (!net_pkt_append_##type##_timeout(pkt, value,	\
+						     PKT_WAIT_TIME)) {	\
+			err = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
 int net_icmpv4_send_error(struct net_pkt *orig, u8_t type, u8_t code)
 {
 	int err = -EIO;
@@ -257,12 +283,18 @@ int net_icmpv4_send_error(struct net_pkt *orig, u8_t type, u8_t code)
 
 	net_pkt_set_iface(pkt, iface);
 
-	net_ipv4_create(pkt, src, dst, iface, IPPROTO_ICMP);
+	if (!net_ipv4_create(pkt, src, dst, iface, IPPROTO_ICMP)) {
+		err = -ENOMEM;
+		goto drop;
+	}
 
-	icmpv4_create(pkt, type, code);
+	if (!icmpv4_create(pkt, type, code)) {
+		err = -ENOMEM;
+		goto drop;
+	}
 
 	/* Appending unused part, filled with 0s */
-	net_pkt_append_be32(pkt, 0);
+	append(pkt, be32, 0);
 
 	if (NET_IPV4_HDR(orig)->proto == IPPROTO_UDP) {
 		copy_len = sizeof(struct net_ipv4_hdr) +
diff --git a/subsys/net/ip/icmpv6.c b/subsys/net/ip/icmpv6.c
index 0135992d519eb4..c9db3acaf291bf 100644
--- a/subsys/net/ip/icmpv6.c
+++ b/subsys/net/ip/icmpv6.c
@@ -555,6 +555,15 @@ int net_icmpv6_send_error(struct net_pkt *orig, u8_t type, u8_t code,
 	return err;
 }
 
+#define append(pkt, type, value)					\
+	do {								\
+		if (!net_pkt_append_##type##_timeout(pkt, value,	\
+						     PKT_WAIT_TIME)) {	\
+			ret = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
 int net_icmpv6_send_echo_request(struct net_if *iface,
 				 struct in6_addr *dst,
 				 u16_t identifier,
@@ -562,27 +571,35 @@ int net_icmpv6_send_echo_request(struct net_if *iface,
 {
 	const struct in6_addr *src;
 	struct net_pkt *pkt;
+	int ret;
 
 	src = net_if_ipv6_select_src_addr(iface, dst);
 
 	pkt = net_pkt_get_reserve_tx(net_if_get_ll_reserve(iface, dst),
-				     K_FOREVER);
+				     PKT_WAIT_TIME);
+	if (!pkt) {
+		return -ENOMEM;
+	}
 
-	pkt = net_ipv6_create(pkt, src, dst, iface, IPPROTO_ICMPV6);
+	if (!net_ipv6_create(pkt, src, dst, iface, IPPROTO_ICMPV6)) {
+		ret = -ENOMEM;
+		goto drop;
+	}
 
 	net_pkt_set_family(pkt, AF_INET6);
 	net_pkt_set_iface(pkt, iface);
 
-	net_pkt_append_u8(pkt, NET_ICMPV6_ECHO_REQUEST);
-	net_pkt_append_u8(pkt, 0);   /* code */
-	net_pkt_append_be16(pkt, 0); /* checksum */
-	net_pkt_append_be16(pkt, identifier);
-	net_pkt_append_be16(pkt, sequence);
+	append(pkt, u8, NET_ICMPV6_ECHO_REQUEST);
+	append(pkt, u8, 0);     /* code */
+	append(pkt, be16, 0);   /* checksum */
+	append(pkt, be16, identifier);
+	append(pkt, be16, sequence);
 
 	net_ipaddr_copy(&NET_IPV6_HDR(pkt)->src, src);
 	net_ipaddr_copy(&NET_IPV6_HDR(pkt)->dst, dst);
 
 	if (net_ipv6_finalize(pkt, IPPROTO_ICMPV6) < 0) {
+		ret = -ENOMEM;
 		goto drop;
 	}
 
@@ -603,11 +620,13 @@ int net_icmpv6_send_echo_request(struct net_if *iface,
 		return 0;
 	}
 
+	ret = -EIO;
+
 drop:
 	net_pkt_unref(pkt);
 	net_stats_update_icmp_drop(iface);
 
-	return -EIO;
+	return ret;
 }
 
 enum net_verdict net_icmpv6_input(struct net_pkt *pkt,
diff --git a/subsys/net/ip/ipv4.c b/subsys/net/ip/ipv4.c
index dcd2c2123d3b90..febadd0ff1486a 100644
--- a/subsys/net/ip/ipv4.c
+++ b/subsys/net/ip/ipv4.c
@@ -27,13 +27,21 @@
 #include "tcp_internal.h"
 #include "ipv4.h"
 
+/* Timeout for various buffer allocations in this file. */
+#define NET_BUF_TIMEOUT K_MSEC(50)
+
 struct net_pkt *net_ipv4_create(struct net_pkt *pkt,
 				const struct in_addr *src,
 				const struct in_addr *dst,
 				struct net_if *iface,
 				u8_t next_header_proto)
 {
-	struct net_buf *header = net_pkt_get_frag(pkt, K_FOREVER);
+	struct net_buf *header;
+
+	header = net_pkt_get_frag(pkt, NET_BUF_TIMEOUT);
+	if (!header) {
+		return NULL;
+	}
 
 	net_pkt_frag_insert(pkt, header);
 
diff --git a/subsys/net/ip/ipv4.h b/subsys/net/ip/ipv4.h
index ae4381761d8ef9..d38552d84f0401 100644
--- a/subsys/net/ip/ipv4.h
+++ b/subsys/net/ip/ipv4.h
@@ -31,7 +31,8 @@
  * @param iface Network interface
  * @param next_header Protocol type of the next header after IPv4 header.
  *
- * @return Return network packet that contains the IPv4 packet.
+ * @return Return network packet that contains the IPv4 packet or NULL if
+ * network packet could not be allocated.
  */
 struct net_pkt *net_ipv4_create(struct net_pkt *pkt,
 				const struct in_addr *src,
diff --git a/subsys/net/ip/ipv6.c b/subsys/net/ip/ipv6.c
index cf8f8f19291922..9ad4f7c3ab019a 100644
--- a/subsys/net/ip/ipv6.c
+++ b/subsys/net/ip/ipv6.c
@@ -42,6 +42,9 @@
  */
 #define ND_NET_BUF_TIMEOUT K_MSEC(100)
 
+/* Timeout for various buffer allocations in this file. */
+#define NET_BUF_TIMEOUT K_MSEC(50)
+
 /* Maximum reachable time value specified in RFC 4861 section
  * 6.2.1. Router Configuration Variables, AdvReachableTime
  */
@@ -739,7 +742,10 @@ struct net_pkt *net_ipv6_create(struct net_pkt *pkt,
 {
 	struct net_buf *header;
 
-	header = net_pkt_get_frag(pkt, K_FOREVER);
+	header = net_pkt_get_frag(pkt, NET_BUF_TIMEOUT);
+	if (!header) {
+		return NULL;
+	}
 
 	net_pkt_frag_insert(pkt, header);
 
@@ -901,7 +907,12 @@ static struct net_pkt *update_ll_reserve(struct net_pkt *pkt,
 
 	while (orig_frag) {
 		if (!room_len) {
-			frag = net_pkt_get_frag(pkt, K_FOREVER);
+			frag = net_pkt_get_frag(pkt, NET_BUF_TIMEOUT);
+			if (!frag) {
+				net_pkt_unref(pkt);
+				net_pkt_frag_unref(orig_frag);
+				return NULL;
+			}
 
 			net_pkt_frag_add(pkt, frag);
 
@@ -2802,6 +2813,24 @@ static enum net_verdict handle_ra_input(struct net_pkt *pkt)
 }
 #endif /* CONFIG_NET_IPV6_ND */
 
+#define append(pkt, type, value)					\
+	do {								\
+		if (!net_pkt_append_##type##_timeout(pkt, value,	\
+						     NET_BUF_TIMEOUT)) { \
+			ret = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
+#define append_all(pkt, size, value)					\
+	do {								\
+		if (!net_pkt_append_all(pkt, size, value,		\
+					NET_BUF_TIMEOUT)) {		\
+			ret = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
 #if defined(CONFIG_NET_IPV6_MLD)
 #define MLDv2_LEN (2 + 1 + 1 + 2 + sizeof(struct in6_addr) * 2)
 
@@ -2810,20 +2839,24 @@ static struct net_pkt *create_mldv2(struct net_pkt *pkt,
 				    u16_t record_type,
 				    u8_t num_sources)
 {
-	net_pkt_append_u8(pkt, record_type);
-	net_pkt_append_u8(pkt, 0); /* aux data len */
-	net_pkt_append_be16(pkt, num_sources); /* number of addresses */
-	net_pkt_append_all(pkt, sizeof(struct in6_addr), addr->s6_addr,
-			K_FOREVER);
+	int ret;
+
+	append(pkt, u8, record_type);
+	append(pkt, u8, 0);             /* aux data len */
+	append(pkt, be16, num_sources); /* number of addresses */
+
+	append_all(pkt, sizeof(struct in6_addr), addr->s6_addr);
 
 	if (num_sources > 0) {
 		/* All source addresses, RFC 3810 ch 3 */
-		net_pkt_append_all(pkt, sizeof(struct in6_addr),
-				net_ipv6_unspecified_address()->s6_addr,
-				K_FOREVER);
+		append_all(pkt, sizeof(struct in6_addr),
+			   net_ipv6_unspecified_address()->s6_addr);
 	}
 
 	return pkt;
+
+drop:
+	return NULL;
 }
 
 static int send_mldv2_raw(struct net_if *iface, struct net_buf *frags)
@@ -2837,41 +2870,45 @@ static int send_mldv2_raw(struct net_if *iface, struct net_buf *frags)
 	net_ipv6_addr_create(&dst, 0xff02, 0, 0, 0, 0, 0, 0, 0x0016);
 
 	pkt = net_pkt_get_reserve_tx(net_if_get_ll_reserve(iface, &dst),
-				     K_FOREVER);
+				     NET_BUF_TIMEOUT);
+	if (!pkt) {
+		return -ENOMEM;
+	}
 
-	pkt = net_ipv6_create(pkt,
-			      net_if_ipv6_select_src_addr(iface, &dst),
-			      &dst,
-			      iface,
-			      NET_IPV6_NEXTHDR_HBHO);
+	if (!net_ipv6_create(pkt,
+			     net_if_ipv6_select_src_addr(iface, &dst),
+			     &dst,
+			     iface,
+			     NET_IPV6_NEXTHDR_HBHO)) {
+		ret = -ENOMEM;
+		goto drop;
+	}
 
 	NET_IPV6_HDR(pkt)->hop_limit = 1; /* RFC 3810 ch 7.4 */
 
 	net_pkt_set_ipv6_hdr_prev(pkt, pkt->frags->len);
 
 	/* Add hop-by-hop option and router alert option, RFC 3810 ch 5. */
-	net_pkt_append_u8(pkt, IPPROTO_ICMPV6);
-	net_pkt_append_u8(pkt, 0); /* length (0 means 8 bytes) */
-
-#define ROUTER_ALERT_LEN 8
+	append(pkt, u8, IPPROTO_ICMPV6);
+	append(pkt, u8, 0);        /* length (0 means 8 bytes) */
 
 	/* IPv6 router alert option is described in RFC 2711. */
-	net_pkt_append_be16(pkt, 0x0502); /* RFC 2711 ch 2.1 */
-	net_pkt_append_be16(pkt, 0); /* pkt contains MLD msg */
-
-	net_pkt_append_u8(pkt, 0); /* padding */
-	net_pkt_append_u8(pkt, 0); /* padding */
+	append(pkt, be16, 0x0502); /* RFC 2711 ch 2.1 */
+	append(pkt, be16, 0);      /* pkt contains MLD msg */
+	append(pkt, u8, 0);        /* padding */
+	append(pkt, u8, 0);        /* padding */
 
 	/* ICMPv6 header */
-	net_pkt_append_u8(pkt, NET_ICMPV6_MLDv2); /* type */
-	net_pkt_append_u8(pkt, 0); /* code */
-	net_pkt_append_be16(pkt, 0); /* chksum */
+	append(pkt, u8, NET_ICMPV6_MLDv2); /* type */
+	append(pkt, u8, 0);                /* code */
+	append(pkt, be16, 0);              /* chksum */
+	append(pkt, be16, 0);              /* reserved field */
+
+#define ROUTER_ALERT_LEN 8
 
 	pkt->frags->len = NET_IPV6ICMPH_LEN + ROUTER_ALERT_LEN;
 	net_pkt_set_iface(pkt, iface);
 
-	net_pkt_append_be16(pkt, 0); /* reserved field */
-
 	/* Insert the actual multicast record(s) here */
 	net_pkt_frag_add(pkt, frags);
 
@@ -2882,9 +2919,14 @@ static int send_mldv2_raw(struct net_if *iface, struct net_buf *frags)
 
 	net_pkt_set_ipv6_ext_len(pkt, ROUTER_ALERT_LEN);
 
-	net_pkt_write_be16(pkt, pkt->frags,
-			   NET_IPV6H_LEN + ROUTER_ALERT_LEN + 2,
-			   &pos, ntohs(~net_calc_chksum_icmpv6(pkt)));
+	if (!net_pkt_write_be16_timeout(pkt, pkt->frags,
+					NET_IPV6H_LEN + ROUTER_ALERT_LEN + 2,
+					&pos,
+					ntohs(~net_calc_chksum_icmpv6(pkt)),
+					NET_BUF_TIMEOUT)) {
+		ret = -ENOMEM;
+		goto drop;
+	}
 
 	ret = net_send_data(pkt);
 	if (ret < 0) {
@@ -2912,16 +2954,23 @@ static int send_mldv2(struct net_if *iface, const struct in6_addr *addr,
 	int ret;
 
 	pkt = net_pkt_get_reserve_tx(net_if_get_ll_reserve(iface, NULL),
-				     K_FOREVER);
+				     NET_BUF_TIMEOUT);
+	if (!pkt) {
+		return -ENOMEM;
+	}
 
-	net_pkt_append_be16(pkt, 1); /* number of records */
+	append(pkt, be16, 1); /* number of records */
 
-	pkt = create_mldv2(pkt, addr, mode, 1);
+	if (!create_mldv2(pkt, addr, mode, 1)) {
+		ret = -ENOMEM;
+		goto drop;
+	}
 
 	ret = send_mldv2_raw(iface, pkt->frags);
 
 	pkt->frags = NULL;
 
+drop:
 	net_pkt_unref(pkt);
 
 	return ret;
@@ -2982,22 +3031,28 @@ static void send_mld_report(struct net_if *iface)
 {
 	struct net_if_ipv6 *ipv6 = iface->config.ip.ipv6;
 	struct net_pkt *pkt;
-	int i, count = 0;
+	int i, ret, count = 0;
 
 	NET_ASSERT(ipv6);
 
 	pkt = net_pkt_get_reserve_tx(net_if_get_ll_reserve(iface, NULL),
-				     K_FOREVER);
+				     NET_BUF_TIMEOUT);
+	if (!pkt) {
+		return;
+	}
 
-	net_pkt_append_u8(pkt, 0); /* This will be the record count */
+	append(pkt, u8, 0); /* This will be the record count */
 
 	for (i = 0; i < NET_IF_MAX_IPV6_MADDR; i++) {
 		if (!ipv6->mcast[i].is_used || !ipv6->mcast[i].is_joined) {
 			continue;
 		}
 
-		pkt = create_mldv2(pkt, &ipv6->mcast[i].address.in6_addr,
-				   NET_IPV6_MLDv2_MODE_IS_EXCLUDE, 0);
+		if (!create_mldv2(pkt, &ipv6->mcast[i].address.in6_addr,
+				  NET_IPV6_MLDv2_MODE_IS_EXCLUDE, 0)) {
+			goto drop;
+		}
+
 		count++;
 	}
 
@@ -3005,13 +3060,17 @@ static void send_mld_report(struct net_if *iface)
 		u16_t pos;
 
 		/* Write back the record count */
-		net_pkt_write_u8(pkt, pkt->frags, 0, &pos, count);
+		if (!net_pkt_write_u8_timeout(pkt, pkt->frags, 0, &pos,
+					      count, NET_BUF_TIMEOUT)) {
+			goto drop;
+		}
 
 		send_mldv2_raw(iface, pkt->frags);
 
 		pkt->frags = NULL;
 	}
 
+drop:
 	net_pkt_unref(pkt);
 }
 
@@ -3308,8 +3367,12 @@ static void reassemble_packet(struct net_ipv6_reassembly *reass)
 	}
 
 	/* This one updates the previous header's nexthdr value */
-	net_pkt_write_u8(pkt, pkt->frags, net_pkt_ipv6_hdr_prev(pkt),
-			  &pos, next_hdr);
+	if (!net_pkt_write_u8_timeout(pkt, pkt->frags,
+				      net_pkt_ipv6_hdr_prev(pkt),
+				      &pos, next_hdr, NET_BUF_TIMEOUT)) {
+		net_pkt_unref(pkt);
+		return;
+	}
 
 	if (!net_pkt_compact(pkt)) {
 		NET_ERR("Cannot compact reassembly packet %p", pkt);
@@ -3594,10 +3657,16 @@ static int send_ipv6_fragment(struct net_if *iface,
 	/* And we need to update the last header in the IPv6 packet to point to
 	 * fragment header.
 	 */
-	temp = net_pkt_write_u8(ipv6, ipv6->frags, next_hdr_idx, &pos,
-				NET_IPV6_NEXTHDR_FRAG);
-	if (!temp && pos == 0xffff) {
-		ret = -EINVAL;
+	temp = net_pkt_write_u8_timeout(ipv6, ipv6->frags, next_hdr_idx, &pos,
+					NET_IPV6_NEXTHDR_FRAG,
+					BUF_ALLOC_TIMEOUT);
+	if (!temp) {
+		if (pos == 0xffff) {
+			ret = -EINVAL;
+		} else {
+			ret = -ENOMEM;
+		}
+
 		goto fail;
 	}
 
diff --git a/subsys/net/ip/ipv6.h b/subsys/net/ip/ipv6.h
index 66804561715a54..4ea7dfbb36d66c 100644
--- a/subsys/net/ip/ipv6.h
+++ b/subsys/net/ip/ipv6.h
@@ -134,7 +134,8 @@ int net_ipv6_send_na(struct net_if *iface, const struct in6_addr *src,
  * @param iface Network interface
  * @param next_header_proto Protocol type of the next header after IPv6 header.
  *
- * @return Return network packet that contains the IPv6 packet.
+ * @return Returns the input pkt network packet (which now contains IPv6
+ * header) or NULL if network packet could not be allocated.
  */
 struct net_pkt *net_ipv6_create(struct net_pkt *pkt,
 				const struct in6_addr *src,
diff --git a/subsys/net/ip/net_context.c b/subsys/net/ip/net_context.c
index 2df55fd0e12e5b..9cffcaf78575a5 100644
--- a/subsys/net/ip/net_context.c
+++ b/subsys/net/ip/net_context.c
@@ -884,8 +884,11 @@ static int create_udp_packet(struct net_context *context,
 	if (net_pkt_family(pkt) == AF_INET6) {
 		struct sockaddr_in6 *addr6 = (struct sockaddr_in6 *)dst_addr;
 
-		pkt = net_context_create_ipv6(context, pkt,
-					      NULL, &addr6->sin6_addr);
+		if (!net_context_create_ipv6(context, pkt,
+					     NULL, &addr6->sin6_addr)) {
+			return -ENOMEM;
+		}
+
 		tmp = net_udp_insert(context, pkt,
 				     net_pkt_ip_hdr_len(pkt) +
 				     net_pkt_ipv6_ext_len(pkt),
@@ -904,8 +907,11 @@ static int create_udp_packet(struct net_context *context,
 	if (net_pkt_family(pkt) == AF_INET) {
 		struct sockaddr_in *addr4 = (struct sockaddr_in *)dst_addr;
 
-		pkt = net_context_create_ipv4(context, pkt,
-					      NULL, &addr4->sin_addr);
+		if (!net_context_create_ipv4(context, pkt,
+					     NULL, &addr4->sin_addr)) {
+			return -ENOMEM;
+		}
+
 		tmp = net_udp_insert(context, pkt, net_pkt_ip_hdr_len(pkt),
 				     addr4->sin_port);
 		if (!tmp) {
diff --git a/subsys/net/ip/rpl.c b/subsys/net/ip/rpl.c
index 9f8de3cf9034d1..1b3d469042fd24 100644
--- a/subsys/net/ip/rpl.c
+++ b/subsys/net/ip/rpl.c
@@ -58,6 +58,8 @@
 #include "rpl.h"
 #include "net_stats.h"
 
+#define BUF_TIMEOUT K_MSEC(100)
+
 #define NET_RPL_DIO_GROUNDED         0x80
 #define NET_RPL_DIO_MOP_SHIFT        3
 #define NET_RPL_DIO_MOP_MASK         0x38
@@ -458,12 +460,45 @@ struct net_route_entry *net_rpl_add_route(struct net_rpl_dag *dag,
 	return route;
 }
 
-static inline void setup_icmpv6_hdr(struct net_pkt *pkt, u8_t type,
+#define append(pkt, type, value)					\
+	do {								\
+		if (!net_pkt_append_##type##_timeout(pkt, value,	\
+						     BUF_TIMEOUT)) {	\
+			ret = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
+#define append_all(pkt, size, value)					\
+	do {								\
+		if (!net_pkt_append_all(pkt, size, value,		\
+					BUF_TIMEOUT)) {			\
+			ret = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
+#define write_pkt(pkt, frag, offset, pos, type, value)			\
+	do {								\
+		if (!net_pkt_write_##type##_timeout(pkt, frag,		\
+						    offset, pos, value,	\
+						    BUF_TIMEOUT)) {	\
+			ret = -ENOMEM;					\
+			goto drop;					\
+		}							\
+	} while (0)
+
+static inline int setup_icmpv6_hdr(struct net_pkt *pkt, u8_t type,
 				    u8_t code)
 {
-	net_pkt_append_u8(pkt, type);
-	net_pkt_append_u8(pkt, code);
-	net_pkt_append_be16(pkt, 0); /* checksum */
+	int ret = 0;
+
+	append(pkt, u8, type);
+	append(pkt, u8, code);
+	append(pkt, be16, 0); /* checksum */
+
+drop:
+	return ret;
 }
 
 int net_rpl_dio_send(struct net_if *iface,
@@ -478,7 +513,7 @@ int net_rpl_dio_send(struct net_if *iface,
 	int ret;
 
 	pkt = net_pkt_get_reserve_tx(net_if_get_ll_reserve(iface, dst),
-				     K_FOREVER);
+				     BUF_TIMEOUT);
 	if (!pkt) {
 		return -ENOMEM;
 	}
@@ -490,53 +525,57 @@ int net_rpl_dio_send(struct net_if *iface,
 		dst_addr = dst;
 	}
 
-	pkt = net_ipv6_create(pkt, src, dst_addr, iface, IPPROTO_ICMPV6);
+	if (!net_ipv6_create(pkt, src, dst_addr, iface, IPPROTO_ICMPV6)) {
+		net_pkt_unref(pkt);
+		return -ENOMEM;
+	}
 
 	net_pkt_set_iface(pkt, iface);
 
-	setup_icmpv6_hdr(pkt, NET_ICMPV6_RPL, NET_RPL_DODAG_INFO_OBJ);
+	ret = setup_icmpv6_hdr(pkt, NET_ICMPV6_RPL, NET_RPL_DODAG_INFO_OBJ);
+	if (ret < 0) {
+		goto drop;
+	}
 
-	net_pkt_append_u8(pkt, instance->instance_id);
-	net_pkt_append_u8(pkt, dag->version);
-	net_pkt_append_be16(pkt, dag->rank);
+	append(pkt, u8, instance->instance_id);
+	append(pkt, u8, dag->version);
+	append(pkt, be16, dag->rank);
 
 	value = net_rpl_dag_is_grounded(dag) << 8;
 	value |= instance->mop << NET_RPL_DIO_MOP_SHIFT;
 	value |= net_rpl_dag_get_preference(dag) & NET_RPL_DIO_PREFERENCE_MASK;
-	net_pkt_append_u8(pkt, value);
-	net_pkt_append_u8(pkt, instance->dtsn);
+	append(pkt, u8, value);
+	append(pkt, u8, instance->dtsn);
 
 	if (!dst) {
 		net_rpl_lollipop_increment(&instance->dtsn);
 	}
 
 	/* Flags and reserved are set to 0 */
-	net_pkt_append_be16(pkt, 0);
+	append(pkt, be16, 0);
 
-	net_pkt_append_all(pkt, sizeof(struct in6_addr), dag->dag_id.s6_addr,
-			   K_FOREVER);
+	append_all(pkt, sizeof(struct in6_addr), dag->dag_id.s6_addr);
 
 	if (instance->mc.type != NET_RPL_MC_NONE) {
 		net_rpl_of_update_mc(instance);
 
-		net_pkt_append_u8(pkt, NET_RPL_OPTION_DAG_METRIC_CONTAINER);
-		net_pkt_append_u8(pkt, 6);
-		net_pkt_append_u8(pkt, instance->mc.type);
-		net_pkt_append_u8(pkt, instance->mc.flags >> 1);
+		append(pkt, u8, NET_RPL_OPTION_DAG_METRIC_CONTAINER);
+		append(pkt, u8, 6);
+		append(pkt, u8, instance->mc.type);
+		append(pkt, u8, instance->mc.flags >> 1);
+
 		value = (instance->mc.flags & 1) << 7;
-		net_pkt_append_u8(pkt, value |
-				  (instance->mc.aggregated << 4) |
-				  instance->mc.precedence);
+		append(pkt, u8, value | (instance->mc.aggregated << 4) |
+		       instance->mc.precedence);
 
 		if (instance->mc.type == NET_RPL_MC_ETX) {
-			net_pkt_append_u8(pkt, 2);
-			net_pkt_append_be16(pkt, instance->mc.obj.etx);
+			append(pkt, u8, 2);
+			append(pkt, be16, instance->mc.obj.etx);
 
 		} else if (instance->mc.type == NET_RPL_MC_ENERGY) {
-			net_pkt_append_u8(pkt, 2);
-			net_pkt_append_u8(pkt, instance->mc.obj.energy.flags);
-			net_pkt_append_u8(pkt,
-					  instance->mc.obj.energy.estimation);
+			append(pkt, u8, 2);
+			append(pkt, u8, instance->mc.obj.energy.flags);
+			append(pkt, u8, instance->mc.obj.energy.estimation);
 
 		} else {
 			NET_DBG("Cannot send DIO, unknown DAG MC type %u",
@@ -546,36 +585,36 @@ int net_rpl_dio_send(struct net_if *iface,
 		}
 	}
 
-	net_pkt_append_u8(pkt, NET_RPL_OPTION_DAG_CONF);
-	net_pkt_append_u8(pkt, 14);
-	net_pkt_append_u8(pkt, 0); /* No Auth */
-	net_pkt_append_u8(pkt, instance->dio_interval_doublings);
-	net_pkt_append_u8(pkt, instance->dio_interval_min);
-	net_pkt_append_u8(pkt, instance->dio_redundancy);
-	net_pkt_append_be16(pkt, instance->max_rank_inc);
-	net_pkt_append_be16(pkt, instance->min_hop_rank_inc);
+	append(pkt, u8, NET_RPL_OPTION_DAG_CONF);
+	append(pkt, u8, 14);
+	append(pkt, u8, 0); /* No Auth */
+	append(pkt, u8, instance->dio_interval_doublings);
+	append(pkt, u8, instance->dio_interval_min);
+	append(pkt, u8, instance->dio_redundancy);
+	append(pkt, be16, instance->max_rank_inc);
+	append(pkt, be16, instance->min_hop_rank_inc);
 
-	net_pkt_append_be16(pkt, instance->ocp);
-	net_pkt_append_u8(pkt, 0); /* Reserved */
-	net_pkt_append_u8(pkt, instance->default_lifetime);
-	net_pkt_append_be16(pkt, instance->lifetime_unit);
+	append(pkt, be16, instance->ocp);
+	append(pkt, u8, 0); /* Reserved */
+	append(pkt, u8, instance->default_lifetime);
+	append(pkt, be16, instance->lifetime_unit);
 
 	if (dag->prefix_info.length > 0) {
-		net_pkt_append_u8(pkt, NET_RPL_OPTION_PREFIX_INFO);
-		net_pkt_append_u8(pkt, 30); /* length */
-		net_pkt_append_u8(pkt, dag->prefix_info.length);
-		net_pkt_append_u8(pkt, dag->prefix_info.flags);
+		append(pkt, u8, NET_RPL_OPTION_PREFIX_INFO);
+		append(pkt, u8, 30); /* length */
+		append(pkt, u8, dag->prefix_info.length);
+		append(pkt, u8, dag->prefix_info.flags);
 
 		/* First valid lifetime and the second one is
 		 * preferred lifetime.
 		 */
-		net_pkt_append_be32(pkt, dag->prefix_info.lifetime);
-		net_pkt_append_be32(pkt, dag->prefix_info.lifetime);
+		append(pkt, be32, dag->prefix_info.lifetime);
+		append(pkt, be32, dag->prefix_info.lifetime);
+
+		append(pkt, be32, 0); /* reserved */
+		append_all(pkt, sizeof(struct in6_addr),
+			   dag->prefix_info.prefix.s6_addr);
 
-		net_pkt_append_be32(pkt, 0); /* reserved */
-		net_pkt_append_all(pkt, sizeof(struct in6_addr),
-			       dag->prefix_info.prefix.s6_addr,
-			       K_FOREVER);
 	} else {
 		NET_DBG("Prefix info not sent because length was %d",
 			dag->prefix_info.length);
@@ -599,6 +638,7 @@ int net_rpl_dio_send(struct net_if *iface,
 		return 0;
 	}
 
+drop:
 	net_pkt_unref(pkt);
 
 	return ret;
@@ -742,30 +782,34 @@ int net_rpl_dis_send(struct in6_addr *dst, struct net_if *iface)
 	}
 
 	pkt = net_pkt_get_reserve_tx(net_if_get_ll_reserve(iface, dst_addr),
-				     K_FOREVER);
+				     BUF_TIMEOUT);
 	if (!pkt) {
 		return -ENOMEM;
 	}
 
 	src = net_if_ipv6_select_src_addr(iface, dst_addr);
 
-	pkt = net_ipv6_create(pkt, src, dst_addr, iface, IPPROTO_ICMPV6);
+	if (!net_ipv6_create(pkt, src, dst_addr, iface, IPPROTO_ICMPV6)) {
+		ret = -ENOMEM;
+		goto drop;
+	}
 
 	net_pkt_set_iface(pkt, iface);
 
-	setup_icmpv6_hdr(pkt, NET_ICMPV6_RPL, NET_RPL_DODAG_SOLICIT);
+	ret = setup_icmpv6_hdr(pkt, NET_ICMPV6_RPL, NET_RPL_DODAG_SOLICIT);
+	if (ret < 0) {
+		goto drop;
+	}
 
 	/* Add flags and reserved fields */
-	net_pkt_write_u8(pkt, pkt->frags,
-			 sizeof(struct net_ipv6_hdr) +
-			 sizeof(struct net_icmp_hdr),
-			 &pos, 0);
-	net_pkt_write_u8(pkt, pkt->frags, pos, &pos, 0);
+	write_pkt(pkt, pkt->frags,
+		  sizeof(struct net_ipv6_hdr) + sizeof(struct net_icmp_hdr),
+		  &pos, u8, 0);
+	write_pkt(pkt, pkt->frags, pos, &pos, u8, 0);
 
 	ret = net_ipv6_finalize(pkt, IPPROTO_ICMPV6);
 	if (ret < 0) {
-		net_pkt_unref(pkt);
-		return ret;
+		goto drop;
 	}
 
 	ret = net_send_data(pkt);
@@ -776,10 +820,13 @@ int net_rpl_dis_send(struct in6_addr *dst, struct net_if *iface)
 
 		net_stats_update_icmp_sent(iface);
 		net_stats_update_rpl_dis_sent(iface);
-	} else {
-		net_pkt_unref(pkt);
+
+		return 0;
 	}
 
+drop:
+	net_pkt_unref(pkt);
+
 	return ret;
 }
 
@@ -3066,20 +3113,26 @@ int net_rpl_dao_send(struct net_if *iface,
 	}
 
 	pkt = net_pkt_get_reserve_tx(net_if_get_ll_reserve(iface, dst),
-				     K_FOREVER);
+				     BUF_TIMEOUT);
 	if (!pkt) {
 		return -ENOMEM;
 	}
 
-	pkt = net_ipv6_create(pkt, src, dst, iface, IPPROTO_ICMPV6);
+	if (!net_ipv6_create(pkt, src, dst, iface, IPPROTO_ICMPV6)) {
+		ret = -ENOMEM;
+		goto drop;
+	}
 
 	net_pkt_set_iface(pkt, iface);
 
-	setup_icmpv6_hdr(pkt, NET_ICMPV6_RPL, NET_RPL_DEST_ADV_OBJ);
+	ret = setup_icmpv6_hdr(pkt, NET_ICMPV6_RPL, NET_RPL_DEST_ADV_OBJ);
+	if (ret < 0) {
+		goto drop;
+	}
 
 	net_rpl_lollipop_increment(&rpl_dao_sequence);
 
-	net_pkt_append_u8(pkt, instance->instance_id);
+	append(pkt, u8, instance->instance_id);
 
 #if defined(CONFIG_NET_RPL_DAO_SPECIFY_DAG)
 	value |= NET_RPL_DAO_D_FLAG;
@@ -3088,35 +3141,33 @@ int net_rpl_dao_send(struct net_if *iface,
 #if defined(CONFIG_NET_RPL_DAO_ACK)
 	value |= NET_RPL_DAO_K_FLAG;
 #endif
-	net_pkt_append_u8(pkt, value);
-	net_pkt_append_u8(pkt, 0); /* reserved */
-	net_pkt_append_u8(pkt, rpl_dao_sequence);
+	append(pkt, u8, value);
+	append(pkt, u8, 0); /* reserved */
+	append(pkt, u8, rpl_dao_sequence);
 
 #if defined(CONFIG_NET_RPL_DAO_SPECIFY_DAG)
-	net_pkt_append_all(pkt, sizeof(dag->dag_id), dag->dag_id.s6_addr,
-			K_FOREVER);
+	append_all(pkt, sizeof(dag->dag_id), dag->dag_id.s6_addr);
 #endif
 
 	prefixlen = sizeof(*prefix) * CHAR_BIT;
 	prefix_bytes = (prefixlen + 7) / CHAR_BIT;
 
-	net_pkt_append_u8(pkt, NET_RPL_OPTION_TARGET);
-	net_pkt_append_u8(pkt, 2 + prefix_bytes);
-	net_pkt_append_u8(pkt, 0); /* reserved */
-	net_pkt_append_u8(pkt, prefixlen);
-	net_pkt_append_all(pkt, prefix_bytes, prefix->s6_addr, K_FOREVER);
+	append(pkt, u8, NET_RPL_OPTION_TARGET);
+	append(pkt, u8, 2 + prefix_bytes);
+	append(pkt, u8, 0); /* reserved */
+	append(pkt, u8, prefixlen);
+	append_all(pkt, prefix_bytes, prefix->s6_addr);
 
-	net_pkt_append_u8(pkt, NET_RPL_OPTION_TRANSIT);
-	net_pkt_append_u8(pkt, 4); /* length */
-	net_pkt_append_u8(pkt, 0); /* flags */
-	net_pkt_append_u8(pkt, 0); /* path control */
-	net_pkt_append_u8(pkt, 0); /* path seq */
-	net_pkt_append_u8(pkt, lifetime);
+	append(pkt, u8, NET_RPL_OPTION_TRANSIT);
+	append(pkt, u8, 4); /* length */
+	append(pkt, u8, 0); /* flags */
+	append(pkt, u8, 0); /* path control */
+	append(pkt, u8, 0); /* path seq */
+	append(pkt, u8, lifetime);
 
 	ret = net_ipv6_finalize(pkt, IPPROTO_ICMPV6);
 	if (ret < 0) {
-		net_pkt_unref(pkt);
-		return ret;
+		goto drop;
 	}
 
 	ret = net_send_data(pkt);
@@ -3125,10 +3176,13 @@ int net_rpl_dao_send(struct net_if *iface,
 
 		net_stats_update_icmp_sent(iface);
 		net_stats_update_rpl_dao_sent(iface);
-	} else {
-		net_pkt_unref(pkt);
+
+		return 0;
 	}
 
+drop:
+	net_pkt_unref(pkt);
+
 	return ret;
 }
 
@@ -3157,7 +3211,7 @@ static inline int dao_forward(struct net_if *iface,
 	int ret;
 
 	pkt = net_pkt_get_reserve_tx(net_if_get_ll_reserve(iface, dst),
-				     K_FOREVER);
+				     BUF_TIMEOUT);
 	if (!pkt) {
 		return -ENOMEM;
 	}
@@ -3199,26 +3253,31 @@ static int dao_ack_send(struct in6_addr *src,
 		sequence, net_sprint_ipv6_addr(dst));
 
 	pkt = net_pkt_get_reserve_tx(net_if_get_ll_reserve(iface, dst),
-				     K_FOREVER);
+				     BUF_TIMEOUT);
 	if (!pkt) {
 		return -ENOMEM;
 	}
 
-	pkt = net_ipv6_create(pkt, src, dst, iface, IPPROTO_ICMPV6);
+	if (!net_ipv6_create(pkt, src, dst, iface, IPPROTO_ICMPV6)) {
+		net_pkt_unref(pkt);
+		return -ENOMEM;
+	}
 
 	net_pkt_set_iface(pkt, iface);
 
-	setup_icmpv6_hdr(pkt, NET_ICMPV6_RPL, NET_RPL_DEST_ADV_OBJ_ACK);
+	ret = setup_icmpv6_hdr(pkt, NET_ICMPV6_RPL, NET_RPL_DEST_ADV_OBJ_ACK);
+	if (ret < 0) {
+		goto drop;
+	}
 
-	net_pkt_append_u8(pkt, instance->instance_id);
-	net_pkt_append_u8(pkt, 0); /* reserved */
-	net_pkt_append_u8(pkt, sequence);
-	net_pkt_append_u8(pkt, status); /* status */
+	append(pkt, u8, instance->instance_id);
+	append(pkt, u8, 0); /* reserved */
+	append(pkt, u8, sequence);
+	append(pkt, u8, status); /* status */
 
 	ret = net_ipv6_finalize(pkt, IPPROTO_ICMPV6);
 	if (ret < 0) {
-		net_pkt_unref(pkt);
-		return ret;
+		goto drop;
 	}
 
 	ret = net_send_data(pkt);
@@ -3228,11 +3287,14 @@ static int dao_ack_send(struct in6_addr *src,
 
 		net_stats_update_icmp_sent(iface);
 		net_stats_update_rpl_dao_ack_sent(iface);
-	} else {
-		net_pkt_unref(pkt);
+
+		return 0;
 	}
 
-	return 0;
+drop:
+	net_pkt_unref(pkt);
+
+	return ret;
 }
 
 static int forwarding_dao(struct net_rpl_instance *instance,
@@ -3726,6 +3788,7 @@ int net_rpl_update_header(struct net_pkt *pkt, struct in6_addr *addr)
 	u16_t offset;
 	u8_t opt;
 	u8_t len;
+	int ret;
 
 	if (NET_IPV6_HDR(pkt)->nexthdr != NET_IPV6_NEXTHDR_HBHO) {
 		return 0;
@@ -3782,16 +3845,22 @@ int net_rpl_update_header(struct net_pkt *pkt, struct in6_addr *addr)
 	parent = find_parent(net_pkt_iface(pkt),
 			     rpl_default_instance->current_dag, addr);
 	if (!parent || parent != parent->dag->preferred_parent) {
-		net_pkt_write_u8(pkt, pkt->frags, offset, &pos,
-				 NET_RPL_HDR_OPT_DOWN);
+		write_pkt(pkt, pkt->frags, offset, &pos, u8,
+			  NET_RPL_HDR_OPT_DOWN);
 	}
 
 	offset++;
-	net_pkt_write_u8(pkt, pkt->frags, offset, &pos,
-			 rpl_default_instance->instance_id);
-	net_pkt_write_be16(pkt, pkt->frags, pos, &pos,
-			   rpl_default_instance->current_dag->rank);
+
+	write_pkt(pkt, pkt->frags, offset, &pos, u8,
+		  rpl_default_instance->instance_id);
+
+	write_pkt(pkt, pkt->frags, pos, &pos, be16,
+		  rpl_default_instance->current_dag->rank);
+
 	return 0;
+
+drop:
+	return ret;
 }
 
 struct net_buf *net_rpl_verify_header(struct net_pkt *pkt, struct net_buf *frag,
@@ -3905,47 +3974,54 @@ static inline int add_rpl_opt(struct net_pkt *pkt, u16_t offset)
 	/* next header */
 	net_pkt_set_ipv6_hdr_prev(pkt, offset);
 
-	ret = net_pkt_insert_u8(pkt, pkt->frags, offset++,
-				NET_IPV6_HDR(pkt)->nexthdr);
+	ret = net_pkt_insert_u8_timeout(pkt, pkt->frags, offset++,
+					NET_IPV6_HDR(pkt)->nexthdr,
+					BUF_TIMEOUT);
 	if (!ret) {
 		return -EINVAL;
 	}
 
 	/* Option len */
-	ret = net_pkt_insert_u8(pkt, pkt->frags, offset++,
-				NET_RPL_HOP_BY_HOP_LEN - 8);
+	ret = net_pkt_insert_u8_timeout(pkt, pkt->frags, offset++,
+					NET_RPL_HOP_BY_HOP_LEN - 8,
+					BUF_TIMEOUT);
 	if (!ret) {
 		return -EINVAL;
 	}
 
 	/* Sub-option type */
-	ret = net_pkt_insert_u8(pkt, pkt->frags, offset++,
-				NET_IPV6_EXT_HDR_OPT_RPL);
+	ret = net_pkt_insert_u8_timeout(pkt, pkt->frags, offset++,
+					NET_IPV6_EXT_HDR_OPT_RPL,
+					BUF_TIMEOUT);
 	if (!ret) {
 		return -EINVAL;
 	}
 
 	/* Sub-option length */
-	ret = net_pkt_insert_u8(pkt, pkt->frags, offset++,
-				NET_RPL_HDR_OPT_LEN);
+	ret = net_pkt_insert_u8_timeout(pkt, pkt->frags, offset++,
+					NET_RPL_HDR_OPT_LEN,
+					BUF_TIMEOUT);
 	if (!ret) {
 		return -EINVAL;
 	}
 
 	/* RPL option flags */
-	ret = net_pkt_insert_u8(pkt, pkt->frags, offset++, 0);
+	ret = net_pkt_insert_u8_timeout(pkt, pkt->frags, offset++, 0,
+					BUF_TIMEOUT);
 	if (!ret) {
 		return -EINVAL;
 	}
 
 	/* RPL Instance id */
-	ret = net_pkt_insert_u8(pkt, pkt->frags, offset++, 0);
+	ret = net_pkt_insert_u8_timeout(pkt, pkt->frags, offset++, 0,
+					BUF_TIMEOUT);
 	if (!ret) {
 		return -EINVAL;
 	}
 
 	/* RPL sender rank */
-	ret = net_pkt_insert_be16(pkt, pkt->frags, offset++, 0);
+	ret = net_pkt_insert_be16_timeout(pkt, pkt->frags, offset++, 0,
+					  BUF_TIMEOUT);
 	if (!ret) {
 		return -EINVAL;
 	}
@@ -3969,6 +4045,7 @@ static int net_rpl_update_header_empty(struct net_pkt *pkt)
 	u8_t opt_type = 0, opt_len;
 	u8_t instance_id, flags;
 	u16_t pos;
+	int ret;
 
 	NET_DBG("Verifying the presence of the RPL header option");
 
@@ -4033,8 +4110,7 @@ static int net_rpl_update_header_empty(struct net_pkt *pkt)
 	NET_DBG("Updating RPL option");
 
 	/* The offset should point to "rank" right now */
-	net_pkt_write_be16(pkt, frag, offset, &pos,
-			   instance->current_dag->rank);
+	write_pkt(pkt, frag, offset, &pos, be16, instance->current_dag->rank);
 
 	offset -= 2; /* move back to flags */
 
@@ -4050,8 +4126,8 @@ static int net_rpl_update_header_empty(struct net_pkt *pkt)
 		struct net_nbr *nbr;
 
 		if (!route) {
-			net_pkt_write_u8(pkt, frag, offset, &pos,
-					 flags |= NET_RPL_HDR_OPT_FWD_ERR);
+			write_pkt(pkt, frag, offset, &pos, u8,
+				  flags |= NET_RPL_HDR_OPT_FWD_ERR);
 
 			NET_DBG("RPL forwarding error");
 
@@ -4092,21 +4168,24 @@ static int net_rpl_update_header_empty(struct net_pkt *pkt)
 		 * towards the RPL root. If so, we should not
 		 * set the down flag.
 		 */
-		net_pkt_write_u8(pkt, frag, offset, &pos,
-				 flags &= ~NET_RPL_HDR_OPT_DOWN);
+		write_pkt(pkt, frag, offset, &pos, u8,
+			  flags &= ~NET_RPL_HDR_OPT_DOWN);
 
 		NET_DBG("RPL option going up");
 	} else {
 		/* A DAO route was found so we set the down
 		 * flag.
 		 */
-		net_pkt_write_u8(pkt, frag, offset, &pos,
-				 flags |= NET_RPL_HDR_OPT_DOWN);
+		write_pkt(pkt, frag, offset, &pos, u8,
+			  flags |= NET_RPL_HDR_OPT_DOWN);
 
 		NET_DBG("RPL option going down");
 	}
 
 	return 0;
+
+drop:
+	return ret;
 }
 
 int net_rpl_revert_header(struct net_pkt *pkt, u16_t offset, u16_t *pos)
@@ -4156,11 +4235,18 @@ int net_rpl_revert_header(struct net_pkt *pkt, u16_t offset, u16_t *pos)
 	*pos = revert_pos;
 
 	/* Update flags, instance id, sender rank */
-	frag = net_pkt_write_u8(pkt, frag, *pos, pos, flags);
-	frag = net_pkt_write_u8(pkt, frag, *pos, pos, instance_id);
-	frag = net_pkt_write_be16(pkt, frag, *pos, pos, sender_rank);
-	if (!frag && *pos == 0xffff) {
-		return -EINVAL;
+	frag = net_pkt_write_u8_timeout(pkt, frag, *pos, pos, flags,
+					BUF_TIMEOUT);
+	frag = net_pkt_write_u8_timeout(pkt, frag, *pos, pos, instance_id,
+					BUF_TIMEOUT);
+	frag = net_pkt_write_be16_timeout(pkt, frag, *pos, pos, sender_rank,
+					  BUF_TIMEOUT);
+	if (!frag) {
+		if (*pos == 0xffff) {
+			return -EINVAL;
+		} else {
+			return -ENOMEM;
+		}
 	}
 
 	return 0;
diff --git a/subsys/net/ip/udp.c b/subsys/net/ip/udp.c
index f0645ddeeef2ab..8853c409a3299a 100644
--- a/subsys/net/ip/udp.c
+++ b/subsys/net/ip/udp.c
@@ -29,9 +29,10 @@ struct net_pkt *net_udp_append_raw(struct net_pkt *pkt,
 		       PKT_WAIT_TIME);
 	net_pkt_append(pkt, sizeof(dst_port), (u8_t *)&dst_port,
 		       PKT_WAIT_TIME);
-	net_pkt_append_be16(pkt, net_pkt_get_len(pkt) -
-			    net_pkt_ip_hdr_len(pkt) -
-			    net_pkt_ipv6_ext_len(pkt));
+	net_pkt_append_be16_timeout(pkt, net_pkt_get_len(pkt) -
+				    net_pkt_ip_hdr_len(pkt) -
+				    net_pkt_ipv6_ext_len(pkt),
+				    PKT_WAIT_TIME);
 
 	frag = net_frag_get_pos(pkt, net_pkt_ip_hdr_len(pkt) +
 				net_pkt_ipv6_ext_len(pkt) +
